@echo off
echo REF-MOD TEST GROUP

echo Separate sign positions
copy /y ref-mod.1 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff ref-mod.2 result
if errorlevel 1 goto err


echo Static reference modification
copy /y ref-mod.3 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff ref-mod.4 result
if errorlevel 1 goto err

echo Dynamic reference modification
copy /y ref-mod.5 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result
if errorlevel 1 goto err
diff ref-mod.6 result
if errorlevel 1 goto err

echo Static out of bounds
copy /y ref-mod.7 prog.cob > nul
cobc -C -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if not errorlevel 1 goto err
diff ref-mod.8 comp.out
if errorlevel 1 goto err

echo Offset underflow
copy /y ref-mod.9 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result 2>&1
if not errorlevel 1 goto err
diff ref-mod.10 result
if errorlevel 1 goto err

echo Offset overflow
copy /y ref-mod.11 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result 2>&1
if not errorlevel 1 goto err
diff ref-mod.12 result
if errorlevel 1 goto err

echo Length underflow
copy /y ref-mod.13 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result 2>&1
if not errorlevel 1 goto err
diff ref-mod.14 result
if errorlevel 1 goto err

echo Length overflow
copy /y ref-mod.15 prog.cob > nul
cobc -x -debug -Wall -std=cobol2002 -o prog prog.cob > comp.out 2>&1
if errorlevel 1 goto err
prog > result 2>&1
if not errorlevel 1 goto err
diff ref-mod.16 result
if errorlevel 1 goto err

echo REF-MOD TEST PASSED
del test.conf prog.* result comp.out
goto end

:err
	echo REF-MOD TEST FAILED
	pause
:end
